//
//		TEXIO USB488 Access Lib  Ver 1.00
//
//	Copyright(c) 2012  TEXIO TECHNOLOGY CORPORATION.

#include "stdafx.h"
#include  "IF60_API.h"


IF60_API::IF60_API()
{
	m_IF60_APIDll       = NULL;
	m_IF60_DeviceOpen 	= NULL;
	m_IF60_DeviceClose 	= NULL;
	m_IF60_Send			= NULL;
	m_IF60_SendBinary	= NULL;
	m_IF60_Receive		= NULL;
	m_IF60_SetTimeout	= NULL;
	m_IF60_SetRemote	= NULL;
	m_IF60_GetRemote	= NULL;
	m_IF60_DevClear		= NULL;
	m_IF60_GetSTBQuery	= NULL;
	m_IF60_DevClear		= NULL;
	m_IF60_ClearSTB		= NULL;
}

IF60_API::~IF60_API()
{
	if(m_IF60_APIDll != NULL)
		FreeLibrary(m_IF60_APIDll);
}

//////////////////////////////////////////////////
// ֐ :	IFInitialize						//
// @\   : USB IF ̏A					//
//			Cuyъ֐̃nh̎擾	//
// 	  : Ȃ								//
// ߂l : TRUE	I					//
//		    FAULSE	ُI					//
//////////////////////////////////////////////////

BOOL IF60_API::IFInitialize()
{
	m_IF60_APIDll=LoadLibrary((LPCSTR)"IF_60.dll");
	if( m_IF60_APIDll == NULL )
		return FALSE;

	m_IF60_DeviceOpen = (long ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_DeviceOpen");
	if( m_IF60_DeviceOpen == NULL )
		return FALSE;

	m_IF60_DeviceClose = (int ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_DeviceClose");
	if( m_IF60_DeviceClose == NULL )
		return FALSE;

	m_IF60_Send = (int ( __stdcall* )( int , char* )) GetProcAddress(m_IF60_APIDll , "USB488_Send");
	if( m_IF60_Send == NULL )
		return FALSE;

	m_IF60_SendBinary = (int ( __stdcall* )( int ,char *,int , int )) GetProcAddress(m_IF60_APIDll , "USB488_SendBinary");
	if( m_IF60_Send == NULL )
		return FALSE;

	m_IF60_Receive = (int ( __stdcall* )( int  , int , char* )) GetProcAddress(m_IF60_APIDll , "USB488_Receive");
	if( m_IF60_Receive == NULL )
		return FALSE;

	m_IF60_SetTimeout = (int ( __stdcall* )( int  , int )) GetProcAddress(m_IF60_APIDll , "USB488_SetTimeout");
	if( m_IF60_SetTimeout == NULL )
		return FALSE;

	m_IF60_SetRemote = (int ( __stdcall* )( int  , int )) GetProcAddress(m_IF60_APIDll , "USB488_SetRemote");
	if( m_IF60_SetRemote == NULL )
		return FALSE;

	m_IF60_GetRemote  = (int ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_GetRemote");
	if( m_IF60_GetRemote == NULL )
		return FALSE;

	m_IF60_DevClear  = (int ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_DevClear");
	if( m_IF60_DevClear == NULL )
		return FALSE;

	m_IF60_GetSTBQuery  = (int ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_GetSTBQuery");
	if( m_IF60_GetSTBQuery == NULL )
		return FALSE;

	m_IF60_ClearSTB  = (int ( __stdcall* )( int )) GetProcAddress(m_IF60_APIDll , "USB488_ClearSTB");
	if( m_IF60_ClearSTB == NULL )
		return FALSE;

	return TRUE;
} 

//////////////////////////////////////////////////
// ֐:DeviceOpen							//
// @\  :nhI[v				//
//   :long addrs=PCAhX					//
// ߂l:l=Al=s					//
//////////////////////////////////////////////////
long IF60_API::DeviceOpen( int addrs )
{

	if(m_IF60_DeviceOpen == NULL)
		return DLL_ERROR;

	return m_IF60_DeviceOpen( addrs );

}

//////////////////////////////////////////////////
// ֐:DeviceClose							//
// @\  :nhN[Y				//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF60_API::DeviceClose( int hID )
{
	if(m_IF60_DeviceClose == NULL)
		return DLL_ERROR;

	return m_IF60_DeviceClose( hID );

}



//////////////////////////////////////////////////
// ֐:Send									//
// @\  :R}hM							//
//		  int hID :IDԍ						//
//		  char *str:MR}h				//
//////////////////////////////////////////////////

int IF60_API::Send( int hID , char *str )
{
	if(m_IF60_Send == NULL)
		return DLL_ERROR;

	return	m_IF60_Send( hID ,str );
}

//////////////////////////////////////////////////
// ֐:SendBinary							//
// @\  :f[^M							//
//		  int hID :IDԍ						//
//		  char *str:Mf[^					//
//        int iCount:]oCg               //
//        int iMode:I[hAkpPbgt//
//////////////////////////////////////////////////

int IF60_API::SendBinary( int hID , char *str ,int iCount , int iMode )
{
	if(m_IF60_SendBinary == NULL)
		return DLL_ERROR;

	return	m_IF60_SendBinary( hID ,str , iCount , iMode);
}


//////////////////////////////////////////////////
// ֐:Receive								//
// @\  :bZ[WM						//
//		  int hID :IDԍ						//
//		  char &Query:MbZ[W			//
//////////////////////////////////////////////////

int IF60_API::Receive( int hID , int iCount ,char *Query )
{
	if(m_IF60_Receive == NULL)
		return DLL_ERROR;

	return	m_IF60_Receive( hID , iCount ,Query );
}


//////////////////////////////////////////////////
// ֐:SetTimeout							//
// @\  :^CAEgݒ						//
//		  int hID :IDԍ						//
//		  int tTime:^CAEgimsj			//
//////////////////////////////////////////////////

int IF60_API::SetTimeout( int hID , int tTime )
{
	if(m_IF60_SetTimeout == NULL)
		return DLL_ERROR;

	return	m_IF60_SetTimeout( hID ,tTime );
}
//////////////////////////////////////////////////
// ֐:SetRemote								//
// @\  :[g[hݒ					//
//		  int hID :IDԍ						//
//		  int iMode:[h	0:[J			//
//							1:[g			//
//							2:[gFbN	//
//////////////////////////////////////////////////

int IF60_API::SetRemote( int hID , int iMode )
{
	if(m_IF60_SetRemote == NULL)
		return DLL_ERROR;

	return	m_IF60_SetRemote( hID ,iMode );
}

//////////////////////////////////////////////////
// ֐:GetRemote								//
// @\  :[gԂl				//
//   :int hID=ID No.						//
// ߂l:int@mode [h						//
//////////////////////////////////////////////////

int IF60_API::GetRemote( int hID )
{
	if(m_IF60_GetRemote == NULL)
		return DLL_ERROR;

	return m_IF60_GetRemote( hID );

}
//////////////////////////////////////////////////
// ֐:DevClear								//
// @\  :foCXNAo					//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF60_API::DevClear( int hID )
{
	if(m_IF60_DevClear == NULL)
		return DLL_ERROR;

	return m_IF60_DevClear( hID );

}
//////////////////////////////////////////////////
// ֐:GetSTBQuery							//
// @\  :STB荞							//
//   :int hID=ID No.						//
// ߂l:int STB								//
//////////////////////////////////////////////////

int IF60_API::GetSTBQuery( int hID )
{
	if(m_IF60_GetSTBQuery == NULL)
		return DLL_ERROR;

	return m_IF60_GetSTBQuery( hID );

}
//////////////////////////////////////////////////
// ֐:ClearSTB								//
// @\  :STBNA						//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF60_API::ClearSTB( int hID )
{
	if(m_IF60_ClearSTB == NULL)
		return DLL_ERROR;

	return m_IF60_ClearSTB( hID );

}
